/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.ejb.local;

import com.evasion.entity.event.EventData;
import com.evasion.entity.security.User;
import java.util.Date;
import java.util.List;

/**
 *
 * @author sebastien
 */
public interface EventHandlerLocal {

    /**
     * Récupère les évènements qui ont eu lieu depuis une date donnée.
     * Possibilité de spécifier un code évènement spécifique.
     * @param date date de début des évènement. ne peut être null.
     * @param code code évènement particulier. tous si null.
     * @return Liste des évènements correspondant à la recherche.
     */
    List<EventData> getEventSince(Date date, String code);

    /**
     * Récupère les évènements qui ont eu lieu depuis une date donnée.
     * Possibilité de spécifier un code évènement spécifique.
     * @param date date de début des évènement. ne peut être null.
     * @param code code évènement particulier. tous si null.
     * @param plugin nom d'un plugin spécifique à cibler.
     * @return Liste des évènements correspondant à la recherche.
     */
    List<EventData> getEventforPluginSince(Date date, String code, String plugin);

    /**
     * Enregistrer un évènement.
     * @param plugin nom du plugin émetteur.
     * @param entityName nom de l'objet entity ayant subit un évènement.
     * @param entityId id technique de l'objet entity concerné.
     * @param code code évènement.
     * @param auteur auteur à l'origine de l'évènement.
     */
    void addEvent(String plugin, String entityName, String entityId, String code, User auteur);
}
