/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.ejb.local;

import com.evasion.entity.Corporation;
import com.evasion.entity.Partenaire;
import com.evasion.exception.PersistenceViolationException;
import java.util.List;

/**
 *
 * @author sebastien
 */
public interface PartnershipManagerLocal {

    /**
     * Création ou modification d'un partenaire.
     * @param partenaire La partenaire à créer.
     * @return Le partenaire sauvegardé en base.
     * @throws PersistenceViolationException erreur lors de la sauvegarde.
     */
    Partenaire savePartnership(Partenaire partenaire) throws PersistenceViolationException;

    /**
     * Liste les partenaires à l'état actif.
     * @return liste des partenaires actif.
     */
    List<Partenaire> listActivePartenaires();

    /**
     * liste l'ensemble des partenaires.
     * @return tous les partenaires.
     */
    List<Partenaire> listAllPartenaires();

    List<Corporation> listPotentialPartenaires();
}
